/* Scanner definition for simple calculator */

%{
#include <stdio.h>
#include "token.h"

/* the current token, set this to the parsed token */
token_t token;
%}

/* put definitions here */
WhiteSpace  [ \t\r]
NewLine     \n
Digit       [0-9]
IntNumber   {Digit}+
FloatNumber (({Digit}*\.{Digit}+)|({Digit}+\.))([eE][+-]?{Digit}+)?
Number      ({IntNumber}|{FloatNumber})

%%

<<EOF>>       { token.type = T_EOF;     return 0; }
{NewLine}     { token.type = T_NEWLINE; return 0; }
{WhiteSpace}  /* skip */
"+"           { token.type = T_PLUS;    return 0; }
"-"           { token.type = T_MINUS;   return 0; }
"*"           { token.type = T_STAR;    return 0; }
"/"           { token.type = T_SLASH;   return 0; }
"("           { token.type = T_LBRACE;  return 0; }
")"           { token.type = T_RBRACE;  return 0; }
{Number}      { token.type = T_NUMBER; sscanf(yytext, "%lf", &token.number_value); return 0; }
.             { fprintf(stderr, "Unexpected char '%s'\n", yytext); }

%%
